"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const enumerable_1 = require("../enumerable");
const utils_1 = require("../utils");
const exceptions_1 = require("../exceptions");
function average(source, selector) {
    utils_1.throws.ThrowIfNull('source', source);
    if (!enumerable_1.Enumerable.Any(source)) {
        return null;
    }
    selector =
        selector ||
            (x => {
                if (utils_1.IsNullOrUndefined(x)) {
                    return null;
                }
                if (typeof x === 'number') {
                    return x;
                }
                else {
                    throw new exceptions_1.ArgumentNullException('selector', '数值类型以外的数组必须传入 selector');
                }
            });
    let sum = 0;
    let count = 0;
    let allNull = true;
    for (let item of source) {
        let value = selector(item);
        if (!utils_1.IsNullOrUndefined(value)) {
            allNull = false;
            sum += value;
        }
        count++;
    }
    if (allNull) {
        return null;
    }
    return sum / count;
}
exports.average = average;
