"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const enumerable_1 = require("../enumerable");
const equality_comparer_1 = require("../equality-comparer");
const enumerable_container_1 = require("./enumerable-container");
const utils = require("../utils");
const assistance = require("./assistance");
function distinct(source, comparer) {
    utils.throws.ThrowIfNull('source', source);
    if (enumerable_1.Enumerable.Any(source)) {
        comparer = comparer || equality_comparer_1.EqualityComparer.Default();
        return new enumerable_container_1.EnumerableContainer(assistance.distinct(source, (x, y) => comparer.Equals(x, y)));
    }
    return enumerable_1.Enumerable.Empty();
}
exports.distinct = distinct;
