"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils = require("../utils");
function firstOrDefault(source, defaultValue, predicate) {
    utils.throws.ThrowIfNull('source', source);
    for (let item of source) {
        if (predicate) {
            if (predicate(item)) {
                return item;
            }
            continue;
        }
        return item;
    }
    return defaultValue;
}
exports.firstOrDefault = firstOrDefault;
