"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const equality_comparer_1 = require("../equality-comparer");
const grouping_1 = require("../grouping");
const enumerable_container_1 = require("./enumerable-container");
const utils = require("../utils");
const assistance = require("./assistance");
function groupBy(source, keySelector, elementSelector, comparer) {
    utils.throws.ThrowIfNull('source', source);
    utils.throws.ThrowIfNull('keySelector', keySelector);
    let _elementSelector = elementSelector || (x => x);
    comparer = comparer || equality_comparer_1.EqualityComparer.Default();
    return new enumerable_container_1.EnumerableContainer(assistance
        .group(source, keySelector, _elementSelector, (x, y) => comparer.Equals(x, y))
        .map(g => new grouping_1.Grouping(g.Key, new enumerable_container_1.EnumerableContainer(g.List))));
}
exports.groupBy = groupBy;
