"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const equality_comparer_1 = require("../equality-comparer");
const enumerable_container_1 = require("./enumerable-container");
const utils = require("../utils");
const assistance = require("./assistance");
function intersect(first, second, comparer) {
    utils.throws.ThrowIfNull('first', first);
    utils.throws.ThrowIfNull('second', second);
    comparer = comparer || equality_comparer_1.EqualityComparer.Default();
    return new enumerable_container_1.EnumerableContainer(assistance.intersect(assistance.distinct(first, (x, y) => comparer.Equals(x, y)), assistance.distinct(second, (x, y) => comparer.Equals(x, y)), (x, y) => comparer.Equals(x, y)));
}
exports.intersect = intersect;
