"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils = require("../utils");
function lastOrDefault(source, defaultValue, predicate) {
    utils.throws.ThrowIfNull('source', source);
    let found = false;
    let target;
    for (let item of source) {
        if (predicate) {
            if (predicate(item)) {
                target = item;
                found = true;
            }
        }
        else {
            target = item;
            found = true;
        }
    }
    if (found) {
        return target;
    }
    return defaultValue;
}
exports.lastOrDefault = lastOrDefault;
