"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils = require("../utils");
function last(source, predicate) {
    utils.throws.ThrowIfNull('source', source);
    let found = false;
    let target;
    for (let item of source) {
        if (predicate) {
            if (predicate(item)) {
                target = item;
                found = true;
            }
        }
        else {
            target = item;
            found = true;
        }
    }
    if (found) {
        return target;
    }
    if (predicate) {
        utils.throws.ThrowInvalidOperation('没有元素满足条件或源序列为空');
    }
    else {
        utils.throws.ThrowInvalidOperation('源序列为空');
    }
}
exports.last = last;
