"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const exceptions_1 = require("../exceptions");
const utils = require("../utils");
function min(source, selector) {
    utils.throws.ThrowIfNull('source', source);
    selector =
        selector ||
            (x => {
                if (utils.IsNullOrUndefined(x)) {
                    return null;
                }
                if (typeof x === 'number') {
                    return x;
                }
                else {
                    throw new exceptions_1.ArgumentNullException('selector', '数值类型以外的数组必须传入 selector');
                }
            });
    let found = false;
    let target;
    for (let item of source) {
        let value = selector(item);
        if (!utils.IsNullOrUndefined(value)) {
            if (!found) {
                target = value;
                found = true;
            }
            else {
                if (value < target) {
                    target = value;
                }
            }
        }
    }
    if (found) {
        return target;
    }
    return null;
}
exports.min = min;
