"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils = require("../utils");
function singleOrDefault(source, defaultValue, predicate) {
    utils.throws.ThrowIfNull('source', source);
    let found = false;
    let target;
    for (let item of source) {
        if (predicate) {
            if (predicate(item)) {
                if (found) {
                    utils.throws.ThrowInvalidOperation('输入的序列包含多个元素');
                }
                target = item;
                found = true;
            }
        }
        else {
            if (found) {
                utils.throws.ThrowInvalidOperation('输入的序列包含多个元素');
            }
            target = item;
            found = true;
        }
    }
    if (found) {
        return target;
    }
    return defaultValue;
}
exports.singleOrDefault = singleOrDefault;
