"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const enumerable_container_1 = require("./enumerable-container");
const utils = require("../utils");
function skipWhile(source, predicate) {
    utils.throws.ThrowIfNull('source', source);
    utils.throws.ThrowIfNull('predicate', predicate);
    return new enumerable_container_1.EnumerableContainer([...process(source, predicate)]);
}
exports.skipWhile = skipWhile;
function* process(source, predicate) {
    let i = 0;
    let skip = false;
    for (let item of source) {
        if (!skip) {
            if (predicate(item, i++)) {
                continue;
            }
            skip = true;
        }
        yield item;
    }
}
