"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const exceptions_1 = require("../exceptions");
const utils = require("../utils");
function sum(source, selector) {
    utils.throws.ThrowIfNull('source', source);
    selector =
        selector ||
            (x => {
                if (utils.IsNullOrUndefined(x)) {
                    return null;
                }
                if (typeof x === 'number') {
                    return x;
                }
                else {
                    throw new exceptions_1.ArgumentNullException('selector', '数值类型以外的数组必须传入 selector');
                }
            });
    let sum = 0;
    let allNull = true;
    for (let item of source) {
        let value = selector(item);
        if (!utils.IsNullOrUndefined(value)) {
            allNull = false;
            sum += value;
        }
    }
    if (allNull) {
        return null;
    }
    return sum;
}
exports.sum = sum;
