"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const enumerable_container_1 = require("./enumerable-container");
const utils = require("../utils");
function takeWhile(source, predicate) {
    utils.throws.ThrowIfNull('source', source);
    utils.throws.ThrowIfNull('predicate', predicate);
    return new enumerable_container_1.EnumerableContainer([...process(source, predicate)]);
}
exports.takeWhile = takeWhile;
function* process(source, predicate) {
    let i = 0;
    for (let item of source) {
        if (predicate(item, i++)) {
            yield item;
        }
        else {
            break;
        }
    }
}
