"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const enumerable_container_1 = require("./enumerable-container");
const equality_comparer_1 = require("../equality-comparer");
const assistance = require("./assistance");
function union(first, second, comparer) {
    utils_1.throws.ThrowIfNull('first', first);
    utils_1.throws.ThrowIfNull('second', second);
    comparer = comparer || equality_comparer_1.EqualityComparer.Default();
    return new enumerable_container_1.EnumerableContainer(assistance.distinct(assistance.concat(first, second), (x, y) => comparer.Equals(x, y)));
}
exports.union = union;
