"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const enumerable_container_1 = require("./enumerable-container");
const utils = require("../utils");
function where(source, predicate) {
    utils.throws.ThrowIfNull('source', source);
    utils.throws.ThrowIfNull('predicate', predicate);
    return new enumerable_container_1.EnumerableContainer([...filter(source, predicate)]);
}
exports.where = where;
function* filter(source, predicate) {
    let index = 0;
    for (let item of source) {
        if (predicate(item, index++)) {
            yield item;
        }
    }
}
