"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const argument_exception_1 = require("./argument-exception");
class ArgumentOutOfRangeException extends argument_exception_1.ArgumentException {
    constructor(paramName, actualValue, message) {
        super(paramName, composite(paramName, actualValue, message));
    }
    get ActualValue() {
        return this.actualValue;
    }
}
exports.ArgumentOutOfRangeException = ArgumentOutOfRangeException;
function composite(paramName, actualValue, message) {
    if (message) {
        return message;
    }
    if (paramName) {
        if (actualValue !== undefined) {
            return `参数 ${paramName} 的范围越界 ${actualValue}`;
        }
    }
    return '数组下标越界';
}
